﻿var AppData = function() {
    var that = {};
    that.dataSource = null;
    that.selector = null;

    that.init = function(selector) {

        this.selector = selector;
        this.dataSource = new window.kendo.data.DataSource({
            type: "odata",
            transport: {
                read: "http://demos.telerik.com/kendo-ui/service/Northwind.svc/Orders"
            },
            schema: {
                model: {
                    fields: {
                        OrderID: { type: "number" },
                        ShipCountry: { type: "string" },
                        ShipName: { type: "string" },
                        ShipCity: { type: "string" },
                        ShipAddress: { type: "string" },
                        Freight: { type: "number" },
                    }
                }
            },
            pageSize: 30,
            page: 1,
            serverPaging: false,
            serverSorting: false,
            serverFiltering: false,
            serverGrouping: false,
            serverAggregates: false,
            aggregate: [
                { field: "Freight", aggregate: "min" },
                { field: "Freight", aggregate: "max" }
            ]
        });
    };

    return that;
};

var dataList = [];
var current = null;

function getAppData(selector) {

    var found = null;

    for (var i = 0, len = window.dataList.length; i < len; i++) {
        if (window.dataList[i].selector == selector) {
            found = window.dataList[i];
            break;
        }
    }

    if (found === null) {
        found = window.AppData();
        found.init(selector);

        window.dataList.push(found);
    }

    window.current = selector;

    return found;

}

var readClicked = false;


$(document).ready(function() {

    var contentSelector = ".content";

    function getUrlFromHash(hash) {
        var url = hash.replace('index.html#/', '');
        url = url + ".html";
        return url;
    }

    $.sammy(contentSelector, function() {
        this.get(/\#\/(.*)/, function(context) {
            var url = getUrlFromHash(context.path);

            context.load(url).swap();

        });
    }).run('#/test1');

    $(".read").on("click", function(e) {
        e.preventDefault();
        
        if (window.current !== null) {
            window.readClicked = true;
            window.getAppData(window.current).dataSource.read();
        }
        
     });
});